#ifndef __KBDMNG_H__
#define __KBDMNG_H__

#define KEY_MOD_LCTRL	0x01
#define KEY_MOD_LSHIFT	0x02
#define KEY_MOD_LALT	0x04
#define KEY_MOD_LWIN	0x08
#define KEY_MOD_RCTRL	0x10
#define KEY_MOD_RSHIFT	0x20
#define KEY_MOD_RALT	0x40
#define KEY_MOD_RWIN	0x80

#define KEY_NULL		0x00
#define KEY_KANJI		0x01
#define KEY_1			0x02
#define KEY_2			0x03
#define KEY_3			0x04
#define KEY_4			0x05
#define KEY_5			0x06
#define KEY_6			0x07
#define KEY_7			0x08
#define KEY_8			0x09
#define KEY_9			0x0A
#define KEY_0			0x0B
#define KEY_MINUS		0x0C
#define KEY_EQUALS		0x0D
#define KEY_BACKSLASH	0x0E
#define KEY_BACKSPACE	0x0F
#define KEY_TAB			0x10
#define KEY_Q			0x11
#define KEY_W			0x12
#define KEY_E			0x13
#define KEY_R			0x14
#define KEY_T			0x15
#define KEY_Y			0x16
#define KEY_U			0x17
#define KEY_I			0x18
#define KEY_O			0x19
#define KEY_P			0x1A
#define KEY_ATMARK		0x1B
#define KEY_LBLACKET	0x1C
#define KEY_CAPSLOCK	0x1E
#define KEY_A			0x1F
#define KEY_S			0x20
#define KEY_D			0x21
#define KEY_F			0x22
#define KEY_G			0x23
#define KEY_H			0x24
#define KEY_J			0x25
#define KEY_K			0x26
#define KEY_L			0x27
#define KEY_SEMICOLON	0x28
#define KEY_COLON		0x29
#define KEY_RBLACKET	0x2A
#define KEY_RETURN		0x2B
#define KEY_LSHIFT		0x2C
#define KEY_Z			0x2E
#define KEY_X			0x2F
#define KEY_C			0x30
#define KEY_V			0x31
#define KEY_B			0x32
#define KEY_N			0x33
#define KEY_M			0x34
#define KEY_COMMA		0x35
#define KEY_PERIOD		0x36
#define KEY_SLASH		0x37
#define KEY_UNDERBAR	0x38
#define KEY_RSHIFT		0x39
#define KEY_LCTRL		0x3A
#define KEY_LALT		0x3C
#define KEY_SPACE		0x3D
#define KEY_RALT		0x3E
#define KEY_RCTRL		0x40
#define KEY_INSERT		0x4B
#define KEY_DELETE		0x4C
#define KEY_LEFT		0x4F
#define KEY_HOME		0x50
#define KEY_END			0x51
#define KEY_UP			0x53
#define KEY_DOWN		0x54
#define KEY_PAGEUP		0x55
#define KEY_PAGEDOWN	0x56
#define KEY_RIGHT		0x59
#define KEY_NUMLOCK		0x5A
#define KEY_NUM_7		0x5B
#define KEY_NUM_4		0x5C
#define KEY_NUM_1		0x5D
#define KEY_NUM_DIV		0x5F
#define KEY_NUM_8		0x60
#define KEY_NUM_5		0x61
#define KEY_NUM_2		0x62
#define KEY_NUM_0		0x63
#define KEY_NUM_MUL		0x64
#define KEY_NUM_9		0x65
#define KEY_NUM_6		0x66
#define KEY_NUM_3		0x67
#define KEY_NUM_DOT		0x68
#define KEY_NUM_SUB		0x69
#define KEY_NUM_ADD		0x6A
#define KEY_NUM_RETURN	0x6C
#define KEY_ESCAPE		0x6E
#define KEY_F1			0x70
#define KEY_F2			0x71
#define KEY_F3			0x72
#define KEY_F4			0x73
#define KEY_F5			0x74
#define KEY_F6			0x75
#define KEY_F7			0x76
#define KEY_F8			0x77
#define KEY_F9			0x78
#define KEY_F10			0x79
#define KEY_F11			0x7A
#define KEY_F12			0x7B
#define KEY_PRINTSCREEN	0x7C
#define KEY_SCROLLLOCK	0x7D
#define KEY_PAUSE		0x7E
#define KEY_NONCONVERT	0x83
#define KEY_CONVERT		0x84
#define KEY_KANA		0x85

extern void kbdmng_initialize( void );
extern void kbdmng_key_down( UINT8, UINT8 );
extern void kbdmng_key_up( UINT8, UINT8 );

#endif // !__KBDMNG_H__
